-- Author      : Weeperman
-- Create Date : 08/11/2009 19:30:00

function SkilzFrame_OnEvent(self, event, ...)

	if (event == "CHAT_MSG_SKILL") or 
       (event == "WORLD_MAP_UPDATE") or
       (event == "LEARNED_SPELL_IN_TAB") or
       (event == "PLAYER_ENTERING_WORLD") then
       
        local summary = "Character Skills|n"
        local count = 0
        
        local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions()

        local prof1Desc = Skilz_DescribeSkill(prof1)
        if (prof1Desc ~= nil) then
            summary = string.format("%s%s",summary,prof1Desc)
            count = count + 1
        end
        
        local prof2Desc = Skilz_DescribeSkill(prof2)        
        if (prof2Desc ~= nil) then
            summary = string.format("%s%s",summary,prof2Desc)
            count = count + 1
        end
        
        local archaeologyDesc = Skilz_DescribeSkill(archaeology)
        if (archaeologyDesc ~= nil) then
            summary = string.format("%s%s",summary,archaeologyDesc)
            count = count + 1
        end
               
        local fishingDesc = Skilz_DescribeSkill(fishing)
        if (fishingDesc ~= nil) then
            summary = string.format("%s%s",summary,fishingDesc)
            count = count + 1
        end
        
        local cookingDesc = Skilz_DescribeSkill(cooking)
        if (cookingDesc ~= nil) then
            summary = string.format("%s%s",summary,cookingDesc)
            count = count + 1
        end
                
        local firstAidDesc = Skilz_DescribeSkill(firstAid)
        if (firstAidDesc ~= nil) then
            summary = string.format("%s%s",summary,firstAidDesc)
            count = count + 1
        end
        
        SkilzText:SetText(summary)
        
        -- resize the frame
        SkilzFrame:SetHeight((count+1) * 14)        
        SkilzText:SetHeight((count+1) * 14)
	end
end

function Skilz_DescribeSkill(prof)
    local SkillStatus = nil
    if (prof ~= nil) then
               
        local  skillName, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier = GetProfessionInfo(prof)

        if (skillLevel ~= maxSkillLevel) then
    
            local percentage = tonumber(skillLevel) / tonumber(maxSkillLevel)
            local percentageString = string.format("[%4.1f%% of %s]",percentage*100, maxSkillLevel)
                        
            -- colour the percentage gold if greater than 90%
            if (percentage > 0.9) then
                percentageString = string.format("|cffffcc00%s",percentageString)
            end
            
            SkillStatus = string.format("\124T%s:0:0:2:0\124t|cff999900 %s|t:%s|t%s|n", icon, skillName, skillLevel, percentageString)                     
        end

    end
    
    return SkillStatus
end

function SkilzFrame_OnLoad(self)
	self:RegisterEvent("CHAT_MSG_SKILL")
	self:RegisterEvent("WORLD_MAP_UPDATE")    
    self:RegisterEvent("LEARNED_SPELL_IN_TAB")    
    self:RegisterEvent("PLAYER_ENTERING_WORLD")
    
    -- Indicate version at load time
    local version = tostring(GetAddOnMetadata("Skilz","Version"))
	DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffffffSkilz|cffff9900 %s|cffffffff loaded", version))   
end

